import struct

#used by client and server

#commands are always  seny in one block (in order to not stall the other side)
#commands are parsed using the receive function, to ensure no data is lost accidently

default_server_port = 1559

def receive(socket, length):
	received = ""
	while len(received) < length:
		added = socket.recv(length - len(received))
		if added == "":
			raise Exception("Socket was closed")
		received += added
	return received

def get_command_code(socket):
	return receive(socket,1)
	
###################################################################

def send_client_information(socket, client_id):
	socket.send(chr(client_id))
def get_client_information(socket):
	client_id = ord(receive(socket,1))
	return client_id

###################################################################

KEY_UPDATE_CODE = 'K'	
def send_key_information(socket, ship_index, key_index, is_down):
	socket.send(KEY_UPDATE_CODE + chr(ship_index) + chr(key_index) + chr(is_down))
def get_key_information(socket):
	ship_index = ord(receive(socket,1))
	key_index = ord(receive(socket,1))
	is_down = (receive(socket,1) != '\x00')
	return ship_index, key_index, is_down

###################################################################

SHIP_INFORMATION_CODE = 'S'
def send_ship_information(socket, ship_index, ship):
	stream_to_send = SHIP_INFORMATION_CODE
	stream_to_send += chr(ship_index)
	stream_to_send += struct.pack("<ff",ship.position[0],ship.position[1])
	stream_to_send += struct.pack("<f" ,ship.direction)
	stream_to_send += struct.pack("<ff",ship.velocity[0],ship.velocity[1])
	stream_to_send += chr(ship.is_dead)
	socket.send(stream_to_send)
def get_ship_code(socket):
	return ord(receive(socket,1))
def get_ship_information(socket, ship):
	posx,posy = struct.unpack("<ff",receive(socket,8))
	ship.position = [posx,posy]
	ship.direction = struct.unpack("<f",receive(socket,4))[0]
	velx,vely = struct.unpack("<ff",receive(socket,8))
	ship.velocity = [velx,vely]
	ship.is_dead = (receive(socket,1) != '\x00')

	
	
###################################################################

START_GAME_CODE = 'G'
def send_start_game(socket,ship_types):
	buffer = START_GAME_CODE
	for i in range(4):
		buffer += chr(ship_types[i])
	socket.send(buffer)
def get_ship_types(socket):
	ship_types = []
	for i in range(4):
		ship_types.append(ord(receive(socket,1)))
	return ship_types

###################################################################

WINNERS_CODE = 'W'	
def send_winners(socket, winners):
	buffer = WINNERS_CODE
	buffer += chr(len(winners))
	for winner in winners:
		buffer += chr(winner)
	socket.send(buffer)
def get_winners(socket):
	winners_count = ord(receive(socket,1))
	winners = []
	for i in range(winners_count):
		winners.append(ord(receive(socket,1)))
	return winners
###################################################################

#used for level names	
def send_string(socket, string):
	string_len = struct.pack("<H",len(string))
	socket.send(string_len+string)
def get_string(socket):
	string_len = struct.unpack("<H",receive(socket,2))[0]
	return receive(socket,string_len)

