import random

import pygame
from OpenGL import GL

import screen
import server
import level
import sprite
import menu_screen
import ship

class ServerScreen (screen.Screen):
	def __init__(self):
		super(ServerScreen,self).__init__()
		self.server = server.Server()
		self.label = sprite.SpriteImage.getTextSpriteImage("Press SPACE to start the game..", font_size = 24)
		self.ship_labels = []
		self.ship_labels.append(sprite.SpriteImage.getTextSpriteImage("Ship 1: You", font_size = 24))
		self.ship_labels.append(sprite.SpriteImage.getTextSpriteImage("Ship 2: ", font_size = 24))
		self.ship_labels.append(sprite.SpriteImage.getTextSpriteImage("Ship 3: ", font_size = 24))
		self.ship_labels.append(sprite.SpriteImage.getTextSpriteImage("Ship 4: ", font_size = 24))
	
	def draw(self):
		GL.glTranslatef(-400,-300,0)
		sprite.set_color((1,1,1,1))
		
		GL.glPushMatrix()
		GL.glTranslatef((800-self.label.size[0])/2,480,0)
		self.label.draw()
		GL.glPopMatrix()
		
		for i in range(4):
			GL.glPushMatrix()
			GL.glTranslatef(100,180+i*32,0)
			self.ship_labels[i].draw()
			GL.glPopMatrix()
	
	def do_frame(self, time_passed):
		self.server.check_new_client(self)
	
	def start_level(self):
		for i in range(4):
			self.server.ship_types[i] = random.randrange(len(ship.ship_types)-1) #except moon
			if i in self.server.free_ids:
				self.server.ship_types[i] = len(ship.ship_types)-1 #moon
		self.server.stop_listening()
		self.server.send_start_game()
		self.next_level = level.Level(self.server)
	
	def handle_event(self, event):
		if event.type == pygame.KEYDOWN:
			if event.key == pygame.K_SPACE:
				self.start_level()
			if event.key == pygame.K_ESCAPE:
				self.next_level = menu_screen.MenuScreen()
